Package com.sas.metadata.remote

# Interface Group

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

All Known Subinterfaces:
  `SXLEMap`

public interface Group extends PrimaryType
This type represents the ability to group metadata together.

Attributes of Group are:

Associations of Group are:

- `Members`
- `GroupSubscriptions`
- `SoftwareComponents`

## Usage

To create an instance of this Group, use the `factory` create methods.
Example: create a Group with name "Group_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Group myObject = (Group) factory.createComplexMetadataObject(objectStore, "Group_Object", MetadataObjects.GROUP, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_GROUPSUBSCRIPTIONS_NAME`
  Constant used for the name of the GroupSubscriptions association.
  `static final String`
  `ASSOCIATION_MEMBERS_NAME`
  Constant used for the name of the Members association.
  `static final String`
  `ASSOCIATION_SOFTWARECOMPONENTS_NAME`
  Constant used for the name of the SoftwareComponents association.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getGroupSubscriptions()`
  Gets the Association list of `GroupSubscriptions`
  `AssociationList`
  `getGroupSubscriptions(boolean fGoToServer)`
  Gets the Associationlist of `GroupSubscriptions`
  `AssociationList`
  `getMembers()`
  Gets the AssociationList of `Members`
  `AssociationList`
  `getMembers(boolean fGoToServer)`
  Gets the Associationlist of `Members`
  `AssociationList`
  `getSoftwareComponents()`
  Gets the Association list of `SoftwareComponents`
  `AssociationList`
  `getSoftwareComponents(boolean fGoToServer)`
  Gets the Associationlist of `SoftwareComponents`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Members`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setGroupSubscriptions(AssociationList list)`
  Sets the `GroupSubscriptions` list to be `list`.
  `void`
  `setGroupSubscriptions(AssociationList inObjects, int state)`
  Sets the entire GroupSubscriptions list to match the passed in AssociationList, sets the state of the GroupSubscriptions
  `void`
  `setMembers(AssociationList list)`
  Sets the `Members` list to be `list`.
  `void`
  `setMembers(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSoftwareComponents(AssociationList list)`
  Sets the `SoftwareComponents` list to be `list`.
  `void`
  `setSoftwareComponents(AssociationList inObjects, int state)`
  Sets the entire SoftwareComponents list to match the passed in AssociationList, sets the state of the SoftwareComponents

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ASSOCIATION_MEMBERS_NAME

    static final String ASSOCIATION_MEMBERS_NAME
    Constant used for the name of the Members association.

    Members: The members of this group.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_GROUPSUBSCRIPTIONS_NAME

    static final String ASSOCIATION_GROUPSUBSCRIPTIONS_NAME
    Constant used for the name of the GroupSubscriptions association.

    GroupSubscriptions: The channels that use this group.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SOFTWARECOMPONENTS_NAME

    static final String ASSOCIATION_SOFTWARECOMPONENTS_NAME
    Constant used for the name of the SoftwareComponents association.

    SoftwareComponents: *Unknown*

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Members`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getMembers

    AssociationList getMembers() throws RemoteException, MdException
    Gets the AssociationList of `Members`
    Returns:
      Returns the AssociationList of `Members` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getGroupSubscriptions

    AssociationList getGroupSubscriptions() throws RemoteException, MdException
    Gets the Association list of `GroupSubscriptions`
    Returns:
      The AssociationList of `GroupSubscriptions` which can be of type:
      ITChannel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSoftwareComponents

    AssociationList getSoftwareComponents() throws RemoteException, MdException
    Gets the Association list of `SoftwareComponents`
    Returns:
      The AssociationList of `SoftwareComponents` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getMembers

    AssociationList getMembers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Members`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Members` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getGroupSubscriptions

    AssociationList getGroupSubscriptions(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `GroupSubscriptions`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `GroupSubscriptions` which can be of type:
      ITChannel
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSoftwareComponents

    AssociationList getSoftwareComponents(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SoftwareComponents`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `SoftwareComponents` which can be of type:
      SoftwareComponent
      DeployedComponent
      ConfiguredComponent
      ServiceComponent
      ServerComponent
      LogicalServer
      ServerContext
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setMembers

    void setMembers(AssociationList list) throws RemoteException
    Sets the `Members` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMembers

    void setMembers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setGroupSubscriptions

    void setGroupSubscriptions(AssociationList list) throws RemoteException
    Sets the `GroupSubscriptions` list to be `list`. Objects of which can be of type:
    ITChannel
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setGroupSubscriptions

    void setGroupSubscriptions(AssociationList inObjects, int state) throws RemoteException
    Sets the entire GroupSubscriptions list to match the passed in AssociationList, sets the state of the GroupSubscriptions
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSoftwareComponents

    void setSoftwareComponents(AssociationList list) throws RemoteException
    Sets the `SoftwareComponents` list to be `list`. Objects of which can be of type:
    SoftwareComponent
    DeployedComponent
    ConfiguredComponent
    ServiceComponent
    ServerComponent
    LogicalServer
    ServerContext
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSoftwareComponents

    void setSoftwareComponents(AssociationList inObjects, int state) throws RemoteException
    Sets the entire SoftwareComponents list to match the passed in AssociationList, sets the state of the SoftwareComponents
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.